// wwDBGridEx 0.99 - based on wwDBGrid from Infopower 3.0
// new property -  show dbgrid in two colors,like MS Money
// Add property TwoColor : boolean
// Add property ColorL, ColorH : TColor - first, second color
// Add property ColorI : TColor - row color if insert new record
// (Sorry for my English)
// Ilya Zaidelson, Tallinn 1997
// E-Mail elia@nekipo.ee (or iza@anet.ee)
//

unit wwDBGridEx;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids,db, Wwdbigrd, Wwdbgrid;

type
  TwwDBGridEx = class(TwwDBGrid)
  private
    FFixedCols: integer;
    FColorLow, FColorHigh, FColorIns : TColor;
    FTwoColorGrid : Boolean;
    OldColor : TColor;
    RecNOld,RecNCur : LongInt;
    FirstColor : Boolean;
    procedure SetTwoColor(Value : Boolean);
    procedure SetColorH(Value : TColor);
    procedure SetColorL(Value : TColor);
    procedure SetColorI(Value : TColor);
//    procedure DoCalcCellColors(Field: TField; State: TGridDrawState;
//             highlight: boolean; AFont: TFont; ABrush: TBrush); virtual;
    procedure DoCalcCellColors(Field: TField; State: TGridDrawState;
             highlight: boolean; AFont: TFont; ABrush: TBrush); override;
    { Private declarations }
  protected
    { Protected declarations }
{    Function CellColor(ACol, ARow: integer): TColor; override;}
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    { Public declarations }
    property CalcCellRow;
    property RowCount;
    property Row;
    property TopRow;
 published
    property ColorL : TColor read FColorLow write SetColorL;
    property ColorH : TColor read FColorHigh write SetColorH;
    property ColorI : TColor read FColorIns write SetColorI;
    property TwoColor : Boolean read FTwoColorGrid write SetTwoColor;
    { Published declarations }
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Scorp''sWill', [TwwDBGridEx]);
end;

constructor TwwDBGridEx.create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FColorLow:= clWindow;
  FColorIns:= clWindow;
  FColorHigh := clBtnFace;
  FTwoColorGrid := False
end;

destructor TwwDBGridEx.Destroy;
begin
  inherited Destroy;
end;

procedure TwwDBGridEx.SetTwoColor(Value : Boolean);
begin
  if Value <> FTwoColorGrid then
  begin
    FTwoColorGrid := Value;
    Invalidate
  end;
end;

procedure TwwDBGridEx.SetColorH(Value : TColor);
begin
  if Value <> FColorHigh then
  begin
    FColorHigh := Value;
    Invalidate
  end;
end;

procedure TwwDBGridEx.SetColorL(Value : TColor);
begin
  if Value <> FColorLow then
  begin
    FColorLow := Value;
    Invalidate
  end;
end;

procedure TwwDBGridEx.SetColorI(Value : TColor);
begin
  if Value <> FColorIns then
  begin
    FColorIns := Value;
    Invalidate
  end;
end;

procedure TwwDBGridEx.DoCalcCellColors(Field: TField; State: TGridDrawState;
             highlight: boolean; AFont: TFont; ABrush: TBrush);
begin
  If (FTwoColorGrid and (not highlight)) and DataSource.DataSet.Active then
  begin
    RecNCur := DataSource.DataSet.RecNo;
    If (RecNCur mod 2) <> 0 then ABrush.Color := FColorLow
    else ABrush.Color := FColorHigh;
    If RecNCur = -1 then ABrush.Color := FColorIns;
  end;
  inherited DoCalcCellColors(Field, State, highlight, AFont, ABrush);
end;

end.
